﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private FC As FileChooser
	Private Leggi As PoiWorkbook
	Public Importa As Form
	Private Importa_BTN As Button
	Private File_da_Importare As String
	Private Lista_oper_comlete As ListView
	Private Probress_01 As ProgressIndicator
	Private Progress_02 As ProgressBar
	Private Lbl_Completati As Label
	Private Label_Progress As Label
	Private List_op As List
	Private LBL_ver As Label

	Private Lista_View_zip As TableView
	Private BTN_UNZIP As Button
	Private BTN_Cancel As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	Importa.Initialize("Config",600,400)
	
	Importa.Title= "Importazione File XLSX"
	Importa.SetOwner(Parent)
	Importa.RootPane.LoadLayout("Importa.fxml")
	Label_Progress.Text=""
	Cerca_file_zip
End Sub
Public Sub Show As Paint 
	Importa.ShowAndWait
	Log ("Show e aspetto")
End Sub

Sub Cerca_file_zip
	Lista_View_zip.Items.Clear
'Cerca i file zip nella directory dell' APP
	Lista_View_zip.SetColumns(Array As String("File ZIp", "St","Picture"))
	Lista_View_zip.SetSize(380,230)
	Lista_View_zip.SetColumnWidth(0,250)
	Lista_View_zip.SetColumnWidth(1,30)
	Lista_View_zip.SetColumnWidth(2,50)
	Lista_View_zip.SetColumnSortable(0,False)
	'Lista_View_zip.SetColumnSortable(1,False)
	'Lista_View_zip.SetColumnSortable(2,False)
	
	Dim Lista_file_Zip As List
	Lista_file_Zip.Initialize
	Lista_file_Zip =File.ListFiles(File.DirApp)
	
	For Each item In Lista_file_Zip
		Dim Indice As Int =Lista_file_Zip.IndexOf(item)
		Dim Zip_file As String= item
		Dim Verifica As Boolean = Zip_file.Contains(".zip")
		
		Dim Valori(3) As Object
		Dim IMG As ImageView
		IMG.Initialize("")
		
		'Dim Butt As Button
		'Butt.Initialize("BTN_Table")
		
		If Verifica= True Then
			IMG.SetSize(20,20)
			Valori(0)=Zip_file
			IMG.SetImage(fx.LoadImage(File.DirAssets,"exclamation.png"))
			'Butt.SetSize(20,20)
			Valori(1)=IMG
			Valori(2)=""
			
			'Valori(3)=Butt
			Lista_View_zip.Items.Add(Valori)
		End If
		
	Next
'metti le spunte
	For T=0 To Lista_View_zip.Items.Size-1
			Dim In_Tabella() As Object= Lista_View_zip.Items.Get(T)
			Dim Verifica_3 As String = In_Tabella(0)
			Verifica_3=Verifica_3.Replace(".zip","")
		For z =0 To Lista_file_Zip.Size-1
			If Verifica_3 =Lista_file_Zip.Get(z) Then
				'Log(Verifica_3 & " - " & Lista_file_Zip.Get(z))
				Dim IMG As ImageView
				IMG.Initialize("")
				Dim DA_sostituire(3) As Object
				DA_sostituire(0)= In_Tabella(0)
				IMG.SetSize(20,20)
				IMG.SetImage(fx.LoadImage(File.DirAssets,"tick_circle_frame.png"))
				DA_sostituire(1)=IMG
				Dim File_img As Int =Conta_Immagini(Verifica_3)
				DA_sostituire(2)=File_img
				'Dim Butt As Button
				'Butt.Initialize("BTN_Table")
				'Butt.SetSize(20,20)
				'DA_sostituire(3)=Butt
				Lista_View_zip.Items.Set(T,DA_sostituire)
			End If
		Next
	Next
	
End Sub


Sub Conta_Immagini(Dir_da_leggere As String)As Int
	Dim Lista_File As List =File.ListFiles(File.DirApp &"\" & Dir_da_leggere)
'cerca di capire quale è la directory
	For i = 0 To Lista_File.Size-1
		Dim Verifica_5 As String =Lista_File.Get(i)
		If Verifica_5.Contains(".") = False Then
			Dim Lista_IMG As List = File.ListFiles(File.DirApp &"\" & Dir_da_leggere & "\" &Verifica_5)
			'Lista_IMG.Initialize
			Return Lista_IMG.Size
			Log("DIRECTORY  " & Verifica_5)
		End If
	Next
	Log ("")
End Sub

Sub Importa_BTN_Click
	FC.Initialize
	FC.InitialDirectory=File.DirApp
	FC.SetExtensionFilter("File Excel",Array As String ("*.Zip"))
	File_da_Importare=FC.ShowOpen(Importa)
	Label_Progress.Text="Attendere ...."
'lista si operazioni
	
	List_op.Initialize
	List_op.Add("Verifica Coerenza file ..... In corso")
	List_op.Add("Unzip .... In corso")
	List_op.Add("Conversione file Excel .... In corso")
	List_op.Add("Inserimento in DataBase .... In corso")	
	Crea_lista_completi(List_op)
	
'Verifica File
	Dim Verificato As Map
	Verificato.Initialize
	Probress_01.Progress=-1
	Probress_01.Visible=True
	Progress_02.Progress=0
	Progress_02.Visible=True
	Sleep(1000)
	
	Verificato=Verivica_se_File_ok(File_da_Importare)	
	LBL_ver.Text=File_da_Importare
	Log(Verificato)
'Unzippo
	If Verificato.Get("Verificato")=True Then
		List_op.Clear
		List_op.Add("Verifica Coerenza file ..... OK")
		List_op.Add("Unzip .... In corso")
		List_op.Add("Conversione file Excel .... In corso")
		List_op.Add("Inserimento in DataBase .... In corso")
		Crea_lista_completi(List_op)
		Sleep(0)
		Log("Diszippo")
		
		Unzip(File_da_Importare)
		List_op.Clear
		List_op.Add("Verifica Coerenza file ..... OK")
		List_op.Add("Unzip .... OK")
		List_op.Add("Conversione file Excel .... In corso")
		List_op.Add("Inserimento in DataBase .... In corso")
		Crea_lista_completi(List_op)
		Log("Diszippato")
	End If
'Leggi file Excell
	File_da_Importare= File.DirApp &"\" &Verificato.Get("File_name")
	Log("DIRECTORY " & Verificato.Get("Dir"))
	Log ("Nome file " & Verificato.Get("File_name"))
	Log(File_da_Importare)
	LBL_ver.Text=File_da_Importare
	Leggi.InitializeExistingAsync("Lettura","",File_da_Importare,"")
	'Probress_01.Visible=False
End Sub

Sub Lettura_Ready (Success As Boolean)

	Conversione_2
	'Probress_01.Visible=False
End Sub

Sub Conversione_2
	Main.Table_01.SetColumns(Array As String("01","Codice","03","04","05","REV","Descrizione","Nu Nc","Tipo","Figura","11","11","13","14","15","16","17","18"))
	For d =0 To Main.Table_01.ColumnsCount-1
		Main.Table_01.SetColumnWidth(d,50)
	Next
	
	Dim lISTA_CONVERTITA As List
	Dim l1 As List
	l1.Initialize
	lISTA_CONVERTITA.Initialize
	'Apre il foglio 0
	Dim pc As PoiCell
	Dim sheet As PoiSheet = Leggi.GetSheet(0)
	For i =2 To sheet.Rows.Size-1
		Dim row As PoiRow = sheet.GetRow(i)
		Dim cell As PoiCell
		'cell=row.Cells
		Dim Variabile(18) As String
		
		For j=0 To 16 'row.Cells.Size-1
			cell =row.GetCell(j)
			If sheet.GetRow(i).GetCell(j).IsInitialized=True Then
				Dim jcell As JavaObject = cell
				Dim Hyperlink As JavaObject = jcell.RunMethod("getHyperlink", Null)
				If Hyperlink.IsInitialized Then
					Variabile(j)=Hyperlink.RunMethod("getAddress", Null)
					'elimina la parte eccedente al nome del file
					Dim temp As Int = Variabile(j).IndexOf("/")
					If temp >0 Then
						Variabile(j)=  Variabile(j).SubString(temp+1)
					End If
				Else
					pc=(sheet.GetRow(i).GetCell(j))
					pc.CellType=1
					Variabile(j)=pc.Value
				End If
			Else
				Variabile(j)=""
			End If
		Next
		
		'Log("Dimensione lista L1  " & l1.Size)
		Main.Table_01.Items.Add( Variabile)
		Label_Progress.Text= "Record " & (I+1) & " di " & sheet.Rows.Size
		Probress_01.Progress=i/sheet.Rows.Size
		Progress_02.Progress=i/sheet.Rows.Size
		
		Sleep(0)
		
		'Log(NumberFormat( i/sheet.Rows.Size,0,1))
		'l1.Clear
	Next
	List_op.Clear
	List_op.Add("Verifica Coerenza file ..... OK")
	List_op.Add("Unzip .... OK")
	List_op.Add("Conversione file Excel .... OK")
	List_op.Add("Inserimento in DataBase .... In corso")
	Crea_lista_completi(List_op)
	'Log("Dimensione lista " & lISTA_CONVERTITA.Size)
	Leggi.Close
End Sub

Sub Verivica_se_File_ok(File_sel As String)As Map
	Dim Lo_converto As Map
	Lo_converto.Initialize
	Try
		If File_sel <> "" Then
			Dim uZL As SD_ZipLibray
			Dim Contenuto_Zip As List
			uZL.Initialize
			Contenuto_Zip.Initialize
			Contenuto_Zip.AddAll(uZL.unZipList(File_sel))
				
			'Conta i file
			Dim JPG As Int
			Dim XLSX As Int
			Dim Dir As Int
			Dim Dir_name As String
			Dim File_Name As String
			For i =0 To Contenuto_Zip.Size-1
				Dim Contenuto As String =Contenuto_Zip.Get(i)
				Contenuto =Contenuto.ToLowerCase
				If Contenuto.Contains(".jpg") Or Contenuto.Contains(".png")  Then
					JPG=JPG+1
				Else If Contenuto.Contains(".xlsx") Or Contenuto.Contains(".xls") Then
					Log("CONTENUTO " & Contenuto)
					
					File_Name=Contenuto
					
					XLSX=XLSX+1
				else if Contenuto.Contains(".ini") Or Contenuto.Contains(".db")Then
					Dim Temp As Int =Contenuto.IndexOf("/")
					Dir_name=Contenuto.SubString2(0,Temp)
					Dir_name=Dir_name.ToUpperCase
					Dir=Dir+1
				End If
			Next
			Log("Immagini " & JPG)
			Log ("Excel " & XLSX)
			Log("Directory " & Dir & " " & Dir_name)
			Log("File "  & File_Name)
			Log("Totale " &Contenuto_Zip.Size)
			'Probress_01.Visible=False
			If JPG>0 And XLSX>0 And Dir>0 Then
				
				Lo_converto.Put("Verificato",True)
				Lo_converto.Put("Dir",Dir_name)
				Lo_converto.Put("File_name",File_Name)
				Return Lo_converto
			Else
				Lo_converto.Put("Verificato",False)
				Lo_converto.Put("Dir",Dir_name)
				Lo_converto.Put("File_name",File_Name)
				Return Lo_converto
			End If
			
			'Unzip(File_da_Importare)
			'Dim Dir_Da_Creare As String =Contenuto_Zip.Get(0)
			'Dim Temp As Int =Dir_Da_Creare.IndexOf("/")
			'Dir_Da_Creare=Dir_Da_Creare.SubString2(0,Temp)
			'Log(Dir_Da_Creare & " " & Temp)
		End If
	Catch
		Log(LastException)
		Dim Messaggio As String
		Messaggio=File_sel & Chr(13)&Chr(10)
		Messaggio=Messaggio & Chr(13)&Chr(10)
		Messaggio=Messaggio & "Questo non è un file compresso"& Chr(13)&Chr(10)
		'Messaggio=Messaggio & "Vuoi tentare ugualmente la conversione ?"
			
		Dim Res As Int =fx.Msgbox2(Importa,Messaggio ,"Attenzione","","","No",fx.MSGBOX_INFORMATION)
		If Res = fx.DialogResponse.POSITIVE Then
			Log("SALVO")
		Else
			Log("NON SALVO")
		End If
		Lo_converto.Put("Verificato",False)
		Lo_converto.Put("Dir",Dir_name)
		Lo_converto.Put("File_name",File_Name)
		Return Lo_converto
	End Try
	
	
End Sub
Sub Unzip (File_da_Unzip As String)
	Dim UnZL As SD_ZipLibray
	
	UnZL.Initialize
	
	UnZL.unZip(File_da_Unzip,File.DirApp & "\" & "Immagini")
End Sub

Sub Crea_lista_completi(da_scrivere As List)
	Lista_oper_comlete.Items.Clear
	For i = 0 To da_scrivere.Size-1
		Dim lbl As Label
		lbl.Initialize("")
		lbl.Text =da_scrivere.Get(i)
		Lista_oper_comlete.Items.Add(lbl)
	Next
End Sub

Sub Lista_View_zip_SelectedRowChanged(Index As Int, Row() As Object)
			
			Log(Row(0))
	
End Sub



Sub BTN_UNZIP_Click
'leggi riga selezionata
	Dim Row_sel() As Object = Lista_View_zip.SelectedRowValues
	Try
		Dim Messaggio As String
		Messaggio="File selezionato "&Row_sel(0)& Chr(13) &Chr(10)
		Messaggio=Messaggio& Chr(13) &Chr(10)
		Messaggio=Messaggio & "Decomprimo il file selezionato ?"
		Dim Risposta As Int =fx.Msgbox2(Importa,Messaggio,"Info","OK","Cancel","",fx.MSGBOX_CONFIRMATION)
	Log(Risposta)
	If Risposta=-1 Then
		'unzippa
			Unzip(Row_sel(0))
	End If
		
		
	Catch
		Dim Messaggio As String
		Messaggio="Nessun file selezionato"& Chr(13) &Chr(10)
		Messaggio=Messaggio& Chr(13) &Chr(10)
		Messaggio=Messaggio & "Seleziona prima un file dalla tabella"
		fx.Msgbox2(Importa,Messaggio,"Info","OK","","",fx.MSGBOX_INFORMATION)
	End Try	
	
End Sub

Sub BTN_Cancel_Click
	Importa.Close 
End Sub