﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Public Importa As Form
	Private BTN_Next As Button
	Private BTN_Cancell As Button
	Private BTN_Sel_File As Button
	Private FC As FileChooser
	Private TXT_File_da_importare As TextField
	Private UnZL As SD_ZipLibray
	Private LBL_Info_zip As Label
	Private LBL_Avviso As Label
	Private Tab_Zip As TabPage
	Private Tab_Excel_DB As TabPage
	Private Tab_plane_importa As TabPane
	Private List_View_excel As ListView
	Private BTN_Convert As Button
	Private File_excel_sel As String
	Private Leggi As PoiWorkbook
	Private Prog_Rotonda As ProgressIndicator
	Private LBL_Verifica As Label
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	Importa.Initialize("Config",600,400)
	Importa.Title= "Importazione File XLSX"
	Importa.SetOwner(Parent)
	Importa.RootPane.LoadLayout("Importa_2.fxml")
	LBL_Avviso.Text=""
	LBL_Info_zip.Text=""
'For test go in tab Excel to DB
	Tab_plane_importa.SelectedIndex=1
	
End Sub

Public Sub Show As Paint
	Importa.ShowAndWait
	Log ("Show e aspetto")
End Sub


Sub BTN_Sel_File_Click
	FC.Initialize
	FC.InitialDirectory=File.DirApp
	FC.SetExtensionFilter("File Excel",Array As String ("*.Zip"))
	TXT_File_da_importare.text=FC.ShowOpen(Importa)
End Sub

Sub BTN_Cancell_Click
	Importa.Close
End Sub

Sub BTN_Next_Click
	If File.Exists("",TXT_File_da_importare.Text)=True  Then
		UnZL.Initialize	
		UnZL.unZip(TXT_File_da_importare.TEXT,File.DirApp & "\" & "Immagini")
		Tab_plane_importa.SelectedIndex=1
	End If
	
End Sub

Sub TXT_File_da_importare_TextChanged (Old As String, New As String)
	LBL_Info_zip.Text=""
	LBL_Avviso.Text=""
	If File.Exists("",TXT_File_da_importare.Text)=True  Then
		Verifica_zip
	End If
	
End Sub

Sub Verifica_zip
		LBL_Info_zip.Text="Attendere"
		LBL_Avviso.Text=""
		Sleep(10)
		UnZL.Initialize
		Dim Lista_zip As List=UnZL.unZipList(TXT_File_da_importare.Text)
		Dim Directory As String
		Dim Nome_File As String
		Dim Immagini As Int=0
		For i =0 To Lista_zip.Size-1
'Cerca Directory
			Dim Verifica_5 As String =Lista_zip.Get(i)
			Verifica_5=Verifica_5.ToUpperCase
			If Verifica_5.Contains(".DB") = True  Or Verifica_5.Contains(".INI")=True  Then
				Dim Temp As Int =Verifica_5.IndexOf("/")
				Directory=Verifica_5.SubString2(0,Temp)
			End If
'Cerca Immagini
			If Verifica_5.Contains(".JPG") = True  Or Verifica_5.Contains(".PNG")=True  Then
				Immagini=Immagini+1
			End If
'Cerca file Excel
			If Verifica_5.Contains(".XLS") = True  Or Verifica_5.Contains(".XLSX")=True  Then
				Nome_File= Verifica_5
			End If
		Next
		LBL_Info_zip.Text= "Info file"& Chr(13)& Chr(10)
		'LBL_Info_zip.Text=LBL_Info_zip.Text & Chr(13)& Chr(10)
		LBL_Info_zip.Text=LBL_Info_zip.Text & "Strumento       = " & Directory & Chr(13)& Chr(10)
		LBL_Info_zip.Text=LBL_Info_zip.Text & "Numero Immagini = " & Immagini & Chr(13)& Chr(10)
		LBL_Info_zip.Text=LBL_Info_zip.Text & "File Excel      = " & Nome_File & Chr(13)& Chr(10)
		LBL_Avviso.Text="ATTENZIONE premi NEXT per Decomprimere"
	
End Sub

Sub Tab_plane_importa_TabChanged (SelectedTab As TabPage)
	List_View_excel.Items.Clear
'File in directory 'Immagini'
	If SelectedTab.Text ="Excel to DB" Then
'Riempie la lista con i file 'xls' e 'xlsx'
		Dim Lista_temp As List = File.ListFiles(File.DirApp & "\Immagini\")
		For i=0 To Lista_temp.Size-1
			Dim Temp As String =Lista_temp.Get(i)
			Dim temp2 As String = Temp
			Temp=Temp.ToLowerCase
			If Temp.EndsWith(".xls") Or Temp.EndsWith(".xlsx") Then
				List_View_excel.Items.Add(temp2)
			End If
			
		Next
	End If
	
End Sub

Sub BTN_Convert_Click
	File_excel_sel=File.DirApp & "\Immagini\" & File_excel_sel
	Log(File_excel_sel)
	'Prog_Rotonda.Visible=True
	'Sleep(10)
	'Leggi.InitializeExistingAsync("Lettura","",File_excel_sel,"")
	Leggi.InitializeExisting("",File_excel_sel,"")
	LBL_Verifica.Text="READ "
	LBL_Verifica.Text=LBL_Verifica.Text & " "& Leggi.IsInitialized
End Sub

Sub Lettura_Ready (Success As Boolean)
	Log("ho letto")
	Prog_Rotonda.Visible=False
	'Conversione_2
	Leggi.Close
End Sub


Sub List_View_excel_SelectedIndexChanged(Index As Int)
	
	File_excel_sel=List_View_excel.Items.Get(Index)
	BTN_Convert.Enabled=True
End Sub